function EnhancedCategoriesPlugin() {
	this._settings = {
		expandText: '&raquo;',
		contractText: '&laquo;',
		leafText: '-',
		buttonColor: '#CC0000',
		buttonWidth: '10px',
		buttonMargin: '0 5px 0 0'
	};
}

jQuery.extend(EnhancedCategoriesPlugin.prototype, {
	setSettings: function(newSettings) {
		jQuery.extend(this._settings, newSettings || {});
	},
	
	getSettings: function() {
		return this._settings;
	}
});

jQuery(document).ready(function() {
	enhancedCategoriesPlugin = new EnhancedCategoriesPlugin();
});

jQuery.fn.enhancedCategories = function(args) { 
	var defaults = enhancedCategoriesPlugin.getSettings(); 
	jQuery.extend(defaults, args);
	
	return jQuery('li.cat-item', this).each(function() {	
		var hasChildren = (jQuery(this).children('ul.children').length > 0);
		var button = '';
		
		// Make button text
		if (hasChildren) {
			if (defaults.contractChildren==1) {
				button += '<span class="button is_expanded" style="cursor: pointer;">';
				button += defaults.expandText;
				button += '</span>';
			} else {
				button += '<span class="button is_contracted" style="cursor: pointer;">';
				button += defaults.contractText;
				button += '</span>';
			}
		} else {
			button += '<span class="button" style="">';
			button += defaults.leafText;
			button += '</span>';
		}
		
		// Add the button in front of category
		jQuery(this).prepend(button);
		
		// Behaviour of the category
		jQuery(this)
			.css({listStyleType: 'none'})
			.children('span.button')
				.css({ 	width: 	defaults.buttonWidth, 
						margin: defaults.buttonMargin, 
						color: 	defaults.buttonColor 
					})
				.click(function() {
						jQuery(this)
							.siblings('ul')
								.slideToggle()
							.end()
							.each(function() {
								if (jQuery(this).hasClass('is_expanded')) {
									jQuery(this)
										.html(defaults.contractText)
										.removeClass('is_expanded')
										.addClass('is_contracted');
								} else {
									jQuery(this)
										.html(defaults.expandText)
										.removeClass('is_contracted')
										.addClass('is_expanded');
								}
								return this;
							});
					});
					
		jQuery(this).children('ul')
			.css({ 	paddingLeft: defaults.buttonWidth });

		// Add some padding to the RSS images
		jQuery('img', this)
			.css({	margin: '0 5px', 
					padding: '0'
				});

		// Contract child categories if asked
		if (defaults.contractChildren==1) {
			jQuery(this).children('ul').hide();
		}

		return this;
	});
};